<!DOCTYPE html>

<html>

<head>
    {{ template "prelude" }}

    <script>
        async function load_cpu_plot() {
            const data = await load_time_series(
                "sum by (instance) (1 - rate(node_cpu_seconds_total{mode=\"idle\"}[2m]))",
                metric => metric["instance"].split(":")[0],
            );

            Plotly.newPlot(
                document.getElementById("cpu"),
                data,
                {
                    title: "CPU-Auslastung",
                    yaxis: {
                        tickformat: ',.0%',
                        range: [0, 2],
                    },
                    showlegend: true,
                }
            );
        }

        async function load_ram_plot() {
            const data = await load_time_series(
                "1 - node_memory_MemAvailable_bytes / node_memory_MemTotal_bytes",
                metric => metric["instance"].split(":")[0],
            );

            Plotly.newPlot(
                document.getElementById("ram"),
                data,
                {
                    title: "RAM-Auslastung",
                    yaxis: {
                        tickformat: ',.0%',
                        range: [0, 1],
                    },
                    showlegend: true,
                }
            );
        }

        async function load_net_plot() {
            var data = await load_time_series(
                "rate(node_network_receive_bytes_total{device=~\"ens[0-9]+\"}[2m]) / 1024 / 1024",
                metric => "recv/" + metric["instance"].split(":")[0],
            );

            data = data.concat(await load_time_series(
                "rate(node_network_transmit_bytes_total{device=~\"ens[0-9]+\"}[2m]) / 1024 / 1024",
                metric => "send/" + metric["instance"].split(":")[0],
            ));

            Plotly.newPlot(
                document.getElementById("net"),
                data,
                {
                    title: "Netzwerk-Verkehr",
                    yaxis: {
                        ticksuffix: "MB/s",
                    },
                    showlegend: true,
                }
            );
        }

        async function load_disk_plot() {
            var data = await load_time_series(
                "rate(node_disk_read_bytes_total[2m]) / 1024 / 1024",
                metric => "read/" + metric["instance"].split(":")[0],
            );

            data = data.concat(await load_time_series(
                "rate(node_disk_written_bytes_total[2m]) / 1024 / 1024",
                metric => "write/" + metric["instance"].split(":")[0],
            ));

            Plotly.newPlot(
                document.getElementById("disk"),
                data,
                {
                    title: "Festplatten-Durchsatz",
                    yaxis: {
                        ticksuffix: "MB/s",
                    },
                    showlegend: true,
                }
            );
        }

        async function load_time_table() {
            const data = await load_values("node_timex_sync_status");

            document.getElementById("time").innerHTML = data["result"].reduce((html, result) => {
                const instance = result["metric"]["instance"].split(":")[0];
                const status = result["value"][1] === "1";

                const color = status ? "green" : "red";
                const mark = status ? "&#10003;" : "&#10799;";

                return html + ` <span style="color: ${color}">${instance} ${mark}</span>`;
            }, "Zeitsynchronisation:");
        }

        async function load_plots() {
            await Promise.all([
                load_cpu_plot(),
                load_ram_plot(),
                load_net_plot(),
                load_disk_plot(),
                load_time_table(),
            ]);
        }

        window.onload = load_plots;

        if (options.update_interval > 0) {
            window.setInterval(load_plots, options.update_interval * 1000);
        }
    </script>

    <title>Server</title>

    <style>
        body {
            font-family: sans-serif;
        }

        table {
            width: 100%;
        }

        td {
            width: 50%;
        }
    </style>
</head>

<body>
    <table>
        <tr>
            <td id="cpu"></td>
            <td id="ram"></td>
        </tr>
        <tr>
            <td id="net"></td>
            <td id="disk"></td>
        </tr>
        <tr>
            <td id="time"></td>
        </tr>
    </table>
</body>

</html>